package org.herac.tuxguitar.io.ptb.helper;

import org.herac.tuxguitar.song.models.TGDuration;

public class TrackStartHelper {

	private int section;
	private long[][] voices;
	
	public TrackStartHelper(){
		super();
	}

	public void init(int section,int staffs){
		this.section = section;
		this.voices = new long[staffs][2];
	}
	
	public int getSection(){
		return this.section;
	}
	
	public void initVoices(long start){
		for(int i = 0; i < this.voices.length; i ++){
			for(int j = 0; j < this.voices[i].length; j ++){	
				this.voices[i][j] = fixValue(start);
			}
		}
	}		
	
	public long getMaxStart(){
		long result = TGDuration.QUARTER_TIME;
		for(int i = 0; i < this.voices.length; i ++){
			for(int j = 0; j < this.voices[i].length; j ++){	
				result = Math.max(result,this.voices[i][j] );
			}
		}
		return fixValue(result);
	}
	
	public long getVoiceStart(int staff,int voice){
		return this.voices[staff][voice];
	}
	
	public void setVoiceStart(int staff,int voice,long start){
		this.voices[staff][voice] = fixValue(start);
	}
	
	public long fixValue(long value){
		return (((value % (TGDuration.QUARTER_TIME / 2)) + 10  > (TGDuration.QUARTER_TIME / 2))?(value + ((TGDuration.QUARTER_TIME / 2) - (value % (TGDuration.QUARTER_TIME / 2)))):value);
	}	
	
}
